# BlockHunt

## Introduction

Hide and seek is a popular game mode on Minecraft that allows you to hide as blocks and disguise as normal props from
seekers. This plugin allows you to do that but with a lot more features added on such as: shops, stats etc...

This plugin has been heavily inspired from the game-mode "PropHunt", from the game, "Garry's Mod".

**Download and try this plugin out for yourself!**

### Downloads

| Branch  | Plugin version | Compatible Minecraft version |
|---------|----------------|------------------------------|
| Release | **v0.5.0**     | **v1.18+**                   |

#### This plugin requires you to download and install two additional plugins! ([Lib's Disguises](https://www.spigotmc.org/resources/libs-disguises.81/) and [ProtocolLib](http://dev.bukkit.org/bukkit-plugins/protocollib/))

### Support

| Method                      | Link                                                                   |
|-----------------------------|------------------------------------------------------------------------|
| **Issues/Tickets on Gitea** | [Click Here](https://git.knarcraft.net/EpicKnarvik97/BlockHunt/issues) |

### Features

* Custom wand for selection arena.
* Multiple arenas.
* **Join/Leave signs!**
* Arena full bypass.
* Configurable blocks.
* **Solid blocks like the Hives!**
* Enable commands per arena.
* Executing commands on win.
* **Shop with tokens!**
* Instant respawn.
* **_And more!_**

## Commands & Permissions

_**Note:** Instead of using /BlockHunt you could use:_

* /bh
* /hideandseek
* /seekandfind (from my old plugin)

<> = Required [] = Optional

| Command                                                            | Description                                       | Permission                  | Default allowed                              |
|--------------------------------------------------------------------|---------------------------------------------------|-----------------------------|----------------------------------------------|
| `/BlockHunt [info/i]`                                              | Displays the plugin's info.                       | blockhunt.info              | All players have this permission by default. |
| `/BlockHunt <help/h>`                                              | Shows a list of commands.                         | blockhunt.help              | All players have this permission by default. |
| `/BlockHunt <reload/r>`                                            | Reloads all configs.                              | blockhunt.reload            | blockhunt.admin                              |                                                 
| `/BlockHunt <join/j> <arenaName>`                                  | Joins a BlockHunt game.                           | blockhunt.join              | blockhunt.player                             |                                                 
| `/BlockHunt <leave/l>`                                             | Leave a BlockHunt game.                           | blockhunt.leave             | blockhunt.player                             |
| `/BlockHunt <list/li>`                                             | Shows a list of available arenas.                 | blockhunt.list              | blockhunt.player                             |
| `/BlockHunt <shop/sh>`                                             | Opens the BlockHunt shop.                         | blockhunt.shop              | blockhunt.player                             |                                                 
| `/BlockHunt <start/go> <arenaName>`                                | Forces an arena to start.                         | blockhunt.start             | blockhunt.moderator                          |                                                 
| `/BlockHunt <wand/w>`                                              | Gives you the wand selection tool.                | blockhunt.create            | blockhunt.admin                              |                                                 
| `/BlockHunt <create/c> <arenaName>`                                | Creates an arena from your selection.             | blockhunt.create            | blockhunt.admin                              |                                                 
| `/BlockHunt <set/s> <arenaName>`                                   | Opens a panel to set settings.                    | blockhunt.set               | blockhunt.moderator                          |                                                 
| `/BlockHunt <setWarp/sw> <lobby/hiders/seekers/spawn> <arenaName>` | Sets warps for your arena.                        | blockhunt.setWarp           | blockhunt.moderator                          |                                                 
| `/BlockHunt <remove/delete> <arenaName>`                           | Deletes an Arena.                                 | blockhunt.remove            | blockhunt.admin                              |                                                 
| `/BlockHunt <tokens/t> <set/add/take> <%playerName%> <amount>`     | Change someones tokens.                           | blockhunt.tokens            | blockhunt.admin                              |                                                 
|                                                                    | Able to join full games.                          | blockhunt.joinfull          | blockhunt.moderator                          | 
|                                                                    | Able to join/leave using join/leave signs.        | blockhunt.joinsign          | blockhunt.player                             |                                                 
|                                                                    | Able to create a join/leave sign.                 | blockhunt.signcreate        | blockhunt.moderator                          |                                                 
|                                                                    | Gives you the BlockChooser.                       | blockhunt.shop.blockchooser | blockhunt.admin                              |                                                 
|                                                                    | Gives you the ability to do all commands in-game. | blockhunt.allcommands       | Operators                                    |

### Other special permissions

| Permission            | Description                                                        |
|-----------------------|--------------------------------------------------------------------|
| `blockhunt.*`         | All BlockHunt permissions.                                         |
| `blockhunt.player`    | All player related permissions.                                    |
| `blockhunt.moderator` | All moderator related permissions.                                 |
| `blockhunt.admin`     | All admin related permissions.                                     |
| `*`                   | All permissions on your server, including BlockHunt's permissions. |

## How to set up?

See [this video](https://www.youtube.com/watch?feature=player_embedded&v=msPQ1UMiHWg) or use the textual guide below.

### Textual guide

#### Specifying the region

To start setting up your arena, start by using the `/bh wand` command to get the setup wand. Mark the corners of a
square containing your entire arena, like you'd create a WorldGuard region. Right-click with the wand on one corner,
and then left-click with the wand on the opposite corner. Make sure one corner is below the bottom of the arena, and
that the other is above the top of the arena.

#### Creating the arena

Use `/bh create <name>` to create your new arena with name \<name>.

#### Configuring the arena

Use `/bh set <name>` to get a GUI for setting the properties of the arena. See [this](#arena-setup-menu-descriptions)
for information about the various settable values. When you've set the values as wanted, click the book. In the
inventory, put all blocks you want hiders to use.

#### Warps

The last step in the setup is to set the warps.

##### Lobby

Use `/bh sw lobby <name>` to set the lobby at your current location.
The lobby is the location players are teleported to after joining, before the arena starts.

##### Hiders

Use `/bh sw hiders <name>`
to set the hiders spawn. This is where hiders are teleported once the arena starts.

##### Seekers

Use `/bh sw seekers <name>`
to set the seekers location at your current location. The seekers location is where seekers are teleported when the
arena starts. Choose a place where they cannot reach or see the hiders, as they are teleported to the hiders warp once
they are allowed to start seeking.

##### Spawn

Use `/bh sw spawn <name>` to set the locations players will go to when exiting the arena.

#### Signs

You can set up a join sign, which also displays current players, by creating a sign like:

1. `[BlockHunt]`
2. \<name>

You can set up a leave sign, by creating a sign, in the arena and/or lobby, like:

1. `[BlockHunt]`
2. Leave

You can set up a shop sign, by creating a sign like:

1. `[BlockHunt]`
2. Shop

### Arena setup menu descriptions

#### maxPlayers

The maximum amount of players that can join this arena.

#### minPlayers

The minimum amount of players required for a round to start.

#### amountSeekersOnStart

The number of players made into seekers when the game starts.

#### timeInLobbyUntilStart

The amount of seconds to wait in the lobby until the game actually starts. During this time, players can use an item in
their inventory to choose their hide block. Other players can join during this time, until the game starts.

#### waitingTimeSeeker

The number of seconds seekers have to wait before they are allowed to start seeking. This is basically how long the
seekers count for until they start searching for the hiders.

#### gameTime

The amount of seconds a game will last. If the hiders are alive after this time, they win.

#### blockAnnouncerTime

The amount of seconds left when announcing the number of currently hiding players.

#### timeUntilHidersSword

The amount of seconds to wait before allowing hiders to defend themselves with a wooden sword.

#### hidersTokenWin

The number of tokens rewarded if the hiders win.

#### seekersTokenWin

The number of tokens rewarded if the seekers win.

#### killTokens

The number of tokens rewarded if a seeker kills a hider.