package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.Command;
import net.knarcraft.blockhunt.manager.MessageManager;
import net.knarcraft.blockhunt.manager.PermissionsManager;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

public class BlockHuntCommand implements CommandExecutor {

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull org.bukkit.command.Command command, @NotNull String label,
                             String[] arguments) {
        Player player = null;
        if (sender instanceof Player) {
            player = (Player) sender;
        }

        // TODO: This is horrible. Instead, use a map from command label to executor, and pipe the command
        for (Command commandRecord : MemoryStorage.commands) {
            String[] splitArguments = null;
            String[] splitArgumentAliases = null;

            if (commandRecord.args() != null && commandRecord.argumentAliases() != null) {
                splitArguments = commandRecord.args().split("/");
                splitArgumentAliases = commandRecord.argumentAliases().split("/");
            }

            if (!command.getName().equalsIgnoreCase(commandRecord.label())) {
                continue;
            }
            boolean equals = true;

            if (splitArguments == null) {
                equals = arguments.length == 0;
            } else if (arguments.length >= splitArguments.length) {
                for (int i2 = splitArguments.length - 1; i2 >= 0; i2 = i2 - 1) {
                    int loc = splitArguments.length - i2 - 1;
                    if (!splitArguments[loc].equalsIgnoreCase(arguments[loc]) &&
                            !splitArgumentAliases[loc].equalsIgnoreCase(arguments[loc])) {
                        equals = false;
                        break;
                    }
                }
            } else {
                equals = false;
            }

            if (equals) {
                if (PermissionsManager.hasPermission(player, commandRecord.permission(), true)) {
                    if (commandRecord.enabled()) {
                        return commandRecord.command().execute(player, arguments);
                    } else {
                        MessageManager.sendFMessage(player, MessageKey.ERROR_COMMAND_NOT_ENABLED);
                    }
                }

                return true;
            }
        }
        new NotFoundCommand().execute(player, arguments);
        return true;
    }

}
