package net.knarcraft.blockhunt.manager;

import net.knarcraft.blockhunt.command.DefaultCommand;
import net.knarcraft.blockhunt.config.Key;
import net.knarcraft.blockhunt.config.Permission;

import java.util.List;

/**
 * A record keeping track of a command's properties
 *
 * @param name            <p></p>
 * @param args
 * @param argumentAliases
 * @param permission
 * @param help
 * @param enabled
 * @param mainTabList
 * @param command
 * @param usage
 */
public record Command(String name, String args, String argumentAliases, Permission permission,
                      Key help, boolean enabled, List<String> mainTabList, DefaultCommand command, String usage) {

    public String label() {
        return "BlockHunt";
    }

}
